1. Two Sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.数据结构

You may assume that each input would have exactly one solution, and you may not use the same element twice.app

Example:this

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

Boring brushing leetcode.
Found that the subject is a company interview topic.spa

This problem mainly use unordered_map .code

unordered_map allow two or more apper in data.but is  not ordered.blog

this is  my solutation:内存

class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        unordered_map<int, int> mp;
        vector<int> v;
        for (int i = 0; i < nums.size(); ++i ){
            int  x = target - nums[i];
            if (mp.count(x) > 0) {
                v.push_back((mp.find(x))->second);
                v.push_back(i);
                break;
            }
            mp.insert({nums[i],i});
        }
        return v;
    }
};

 

o(n)ci

STL中,map对应的数据结构是红黑树。红黑树是一种近似于平衡的二叉查找树,里面的数据是有序的。在红黑树上作查找操做的时间复杂度为 O(logN)。而unordered_map对应 哈希表,哈希表的特色就是查找效率高,时间复杂度为常数级别 O(1), 而额外空间复杂度则要高出许多。因此对于须要高效率查询的状况,使用unordered_map容器。而若是对内存大小比较敏感或者数据存储要求有序的话,则能够用map容器。 element

相关文章
相关标签/搜索